metadata:
  name: apparmor-utils
  format: "Apertis Test Definition 1.0"
  image-types:
    minimal: [ armhf-internal, armhf, arm64, amd64 ]
    target:  [ armhf-internal, armhf, amd64 ]
    basesdk: [ amd64 ]
    sdk:     [ amd64 ]
  image-deployment:
    - APT
  type: functional
  exec-type: automated
  priority: medium
  maintainer: "Apertis Project"
  description: "Test apparmor_parser and other tools in apparmor package
                can be executed"

  expected:
    - "The test will show on stdout OK,FAIL or SKIP and exit code will be non zero
       if at least one subtest will fail. A similar output will be shown:"
    - |
        >checking /bin/true is enforced: OK -
    - "If the test_profile_syntax test-case in the apparmor-basic-profiles test
       is failing, please report that failure instead: it produces better
       diagnostics."
    - "When that test case is failing, the go in complain mode, change for
       enforced profiles in enforce->complain, change in complaininig profiles in
       enforce->complain, gran total enforce/disable and change for enforced
       profiles in enforce->disable test-cases in this test are also expected to
       fail."

  notes:
    - "Make sure that you have disconnect the ethernet connection to the target
       before you start the tethering process."
    - "Implement a minimum set of test to be sure things works properly. No
       advanced features tested."
    - "This test depends on all AppArmor profiles being syntactically valid, and
       does not have useful diagnostics if they are not. If the test_profile_syntax
       test-case in the apparmor-basic-profiles test fails, please report that
       failure instead. You can mention this failure in the same bug report, but
       please do not report it separately."

install:
  deps:
    - apparmor-utils-tests
    - busybox
    - apertis-tests-apparmor-report
  git-repos:
    - url: https://gitlab.apertis.org/infrastructure/apertis-tests.git
      branch: 'apertis/v2022dev0'

run:
  steps:
    - "# Enter test directory:"
    - cd apertis-tests
    - "# Run the the following commands:"
    - 'common/run-test-in-systemd --name=aa-enforce-test --timeout 90 -- sh /usr/lib/apparmor-utils-tests/aa-enforce-test.sh'
    - 'common/run-test-in-systemd --name=apparmor_parser --timeout 90 -- sh /usr/lib/apparmor-utils-tests/apparmor_parser.sh'
    - sudo journalctl -b -t audit -o cat | /usr/bin/aa_log_extract_tokens.sh ALLOWED DENIED

parse:
  fixupdict:
    FAIL: fail
    OK: pass
    SKIP: skip
  pattern: ^(?P<test_case_id>.+):\s*(?P<result>PASS|pass|FAIL|fail|SKIP|skip|UNKNOWN|unknown)\s*-.*
